
// Include important header files needed to interface with Outpost 2
#include "..\Outpost2DLL\Outpost2DLL.h"
// Include header files to make it easier to build levels
#include "..\OP2Helper\OP2Helper.h"
#include "enum.h"
//do NOT mess w/ this code randomstartinglocswithsf
void RandomizeStartingLocationsE(int numLocations, struct StartLocationE location[])
{
	int i;
	int next;
	struct StartLocationE temp;

	// Randomly reorder the list (backwards)
	for (i = numLocations-1; i; i--)
	{
		// Determine which of the remaining locations to place next in the list
		next = TethysGame::GetRand(i+1);
		// Swap with next list item
		temp = location[i];
		location[i] = location[next];
		location[next] = temp;
	}
}


//functions to animate volcanos
//and stop animation
void SouthEastFlowAni ( int x, int y)
{
	GameMap::SetTile(LOCATION(x, y), 0x489);
	GameMap::SetTile(LOCATION(x, y+1), 0x4A0);
	GameMap::SetTile(LOCATION(x+1, y+1), 0x4AB);
	GameMap::SetTile(LOCATION(x+1, y), 0x494);
}
void SouthFlowAni( int x, int y)
{
	GameMap::SetTile(LOCATION(x, y), 0x474);
	GameMap::SetTile(LOCATION(x, y+1), 0x47E);
}

void SouthWestFlowAni ( int x, int y)
{
	GameMap::SetTile(LOCATION(x+1, y), 0x453);
	GameMap::SetTile(LOCATION(x, y), 0x447);
	GameMap::SetTile(LOCATION(x, y+1), 0x45E);
	GameMap::SetTile(LOCATION(x+1, y+1), 0x469);
}

void SouthEastFlowStopAni ( int x, int y)
{
	GameMap::SetTile(LOCATION(x, y), 0x490);
	GameMap::SetTile(LOCATION(x, y+1), 0x4A8);
	GameMap::SetTile(LOCATION(x+1, y+1), 0x4B2);
	GameMap::SetTile(LOCATION(x+1, y), 0x49C);
}
void SouthFlowStopAni( int x, int y)
{
	GameMap::SetTile(LOCATION(x, y), 0x47B);
	GameMap::SetTile(LOCATION(x, y+1), 0x486);
}

void SouthWestFlowStopAni ( int x, int y)
{
	GameMap::SetTile(LOCATION(x+1, y), 0x45A);
	GameMap::SetTile(LOCATION(x, y), 0x44F);
	GameMap::SetTile(LOCATION(x, y+1), 0x465);
	GameMap::SetTile(LOCATION(x+1, y+1), 0x470);
}
//set old lava flows as lava possible
void SetAllLava()
{
	LOCATION size(1024,1024);
	int x,y,tile;

	size.Clip();
	for (y=0; y<size.y; ++y)
	{
		
		for (x=31; x<size.x; ++x)
		{

			tile=GameMap::GetTile(LOCATION(x,y));
			if (((tile>=0x1B7) && (tile<=0x1F8)) || ((tile>=0x22F) && (tile<=0x25E)) || ((tile>=0x1F9) && (tile<=0x218)) || ((tile>=0x311) && (tile<=0x318)) || ((tile>=0x311) && (tile<=0x318)))
				GameMap::SetLavaPossible(LOCATION(x,y),true);
		
		}
	
	}
}

void PutInitUnits(int x, int y,int i)
{
	Unit lynx;

	map_id weap = mapMicrowave;

	if (Player[i].IsEden())
		weap = mapLaser;
		

	for (int num=0;num<TethysGame::InitialUnits();num++)
	{
		TethysGame::CreateUnit(lynx , mapLynx, LOCATION(x,y), i, weap ,6);
		lynx.DoSetLights(1);
	}

}
void PlaceWreakTigSpeed()
{
	//wreakge placement and passibilty of wreakage loc testing
	LOCATION size2(1024,1024);
	size2.Clip();
	MAP_RECT mr(0,0,size2.x,size2.x);
	int wrx,wry,tt2;
		
	do 
	{
		wrx = mr.RandPt().x+31;
		wry = mr.RandPt().y-1;
		tt2 = GameMap::GetCellType(LOCATION(wrx,wry));
	}
	while ((((tt2 >= 0x08) && (tt2 <= 0x1A)) || (tt2 == 0x01) || (tt2 == 0x06)));
		
	TethysGame::CreateWreck( wrx , wry , (map_id)11999, 0); // Tech #11999 - tiger speed upgrade
}
void SetupDayNight()
{
	TethysGame::SetDaylightEverywhere(1);
	TethysGame::SetDaylightMoves(0);
	
	if (TethysGame::UsesDayNight()) 
	{
		TethysGame::SetDaylightMoves(1);
		//this may need to be changed depending on map size
		GameMap::SetInitialLightLevel(-32);
		TethysGame::SetDaylightEverywhere(0);
	
	}
}
void SetupMorale()
{
	if (TethysGame::UsesMorale())
	{
		TethysGame::FreeMoraleLevel(-1);
	}
	else
	{
		TethysGame::ForceMoraleGood(-1);
	}
}
void SetupSF(int i)
{
	Unit building;

	PlayerBuildingEnum buildingEnum(i, mapStructureFactory);

 // We only want the first one found (if any at all)
	if (buildingEnum.GetNext(building))
	//difficulty
	switch(Player[i].Difficulty())
	{
	case 0:		// Easy
		building.SetFactoryCargo(0, mapTokamak,			mapNone);
		building.SetFactoryCargo(1, mapNursery,			mapNone);
		building.SetFactoryCargo(2, mapUniversity,		mapNone);
		building.SetFactoryCargo(3, mapVehicleFactory,	mapNone);
		building.SetFactoryCargo(4, mapRobotCommand,	mapNone);
		building.SetFactoryCargo(5, mapResidence,		mapNone);
		break;
	case 1:		// Normal
		building.SetFactoryCargo(0, mapTokamak,			mapNone);
		building.SetFactoryCargo(1, mapUniversity,		mapNone);
		building.SetFactoryCargo(2, mapNursery,			mapNone);
		break;
	case 2:		// Hard
		//You get no kits on hard!!!
		break;
	}
		
}

void InitPlayerResourcesToPie(int playerNum)
{
	_Player &player = Player[playerNum];

	switch(player.Difficulty())
	{
	case 0:		// Easy
		player.SetOre(6000);
		player.SetFoodStored(3000);
		player.SetWorkers(27);
		player.SetScientists(18);
		player.SetKids(22);
		break;
	case 1:		// Normal
		player.SetOre(4000);
		player.SetFoodStored(2000);
		player.SetWorkers(24);
		player.SetScientists(15);
		player.SetKids(20);
		break;
	case 2:		// Hard
		player.SetOre(2000);
		player.SetFoodStored(1000);
		player.SetWorkers(20);
		player.SetScientists(12);
		player.SetKids(18);
	}
}

int IsPassible( int x, int y)
{
	int tile = GameMap::GetCellType(LOCATION(x,y));
	if (((tile >= 0x08) && (tile <= 0xB)) || (tile == 0x01))
		return false;
	else
		return true;

}
void CreateBaseWithCargo(int player, int x, int y, struct BaseInfoE &baseInfo)
{
	int i;
	int curX, curY;
	int curX2, curY2;
	Unit unit;

	// Create the base beacon set
	for (i = 0; i < baseInfo.numBeacons; i++)
	{
		BeaconInfo &curBeacon = baseInfo.beaconInfo[i];
		curX = x + curBeacon.x;
		curY = y + curBeacon.y;
		TethysGame::CreateBeacon(curBeacon.type, curX, curY, curBeacon.rare,
						curBeacon.bar, curBeacon.variant);
	}

	// Create the buildings
	for (i = 0; i < baseInfo.numBuilding; i++)
	{
		BuildingInfo &curItem = baseInfo.bldnInfo[i];
		curX = x + curItem.x;
		curY = y + curItem.y;
		TethysGame::CreateUnit(unit, curItem.type, LOCATION(curX, curY), 
						player, mapNone, 0);
		
	}

	// Create the tube lines
	for (i = 0; i < baseInfo.numTubeLine; i++)
	{
		TubeWallInfo &curItem = baseInfo.tubeInfo[i];
		curX = x + curItem.fromX;
		curY = y + curItem.fromY;
		curX2 = x + curItem.toX;
		curY2 = y + curItem.toY;
		CreateTubeOrWallLine(curX, curY, curX2, curY2, mapTube);
	}

	// Create the wall lines
	for (i = 0; i < baseInfo.numWallLine; i++)
	{
		TubeWallInfo &curItem = baseInfo.wallInfo[i];
		curX = x + curItem.fromX;
		curY = y + curItem.fromY;
		curX2 = x + curItem.toX;
		curY2 = y + curItem.toY;
		CreateTubeOrWallLine(curX, curY, curX2, curY2, mapWall);
	}

	// Create the vehicles
	for (i = 0; i < baseInfo.numVehicle; i++)
	{
		VehicleInfoE &curItem = baseInfo.vehicleInfo[i];
		curX = x + curItem.x;
		curY = y + curItem.y;
		TethysGame::CreateUnit(unit, curItem.type, LOCATION(curX, curY), 
						player, curItem.weaponCargo, curItem.dir);
		unit.DoSetLights(1);
		if (unit.GetType() == mapCargoTruck)
			unit.SetTruckCargo( curItem.ctcargo, curItem.cnum);

	}
}